/***************************************************************************
* COPYRIGHT NOTICE
* Copyright 2020 Horizon Robotics, Inc.
* All rights reserved.
***************************************************************************/
#ifndef __HBN_ERROR_H__
#define __HBN_ERROR_H__

#ifdef __cplusplus
extern "C" {
#endif

#include "hbn_vpf_data_info.h"


#define HBN_STATUS_SUCESS (0)
#define HBN_STATUS_INVALID_NODE (1)
#define HBN_STATUS_INVALID_NODETYPE (2)
#define HBN_STATUS_INVALID_HWID (3)
#define HBN_STATUS_INVALID_CTXID (4)
#define HBN_STATUS_INVALID_OCHNID (5)
#define HBN_STATUS_INVALID_ICHNID (6)
#define HBN_STATUS_INVALID_FORMAT (7)
#define HBN_STATUS_INVALID_NULL_PTR (8)
#define HBN_STATUS_INVALID_PARAMETER (9)
#define HBN_STATUS_ILLEGAL_ATTR (10)
#define HBN_STATUS_INVALID_FLOW (11)
#define HBN_STATUS_FLOW_EXIST (12)
#define HBN_STATUS_FLOW_UNEXIST (13)
#define HBN_STATUS_NODE_EXIST (14)
#define HBN_STATUS_NODE_UNEXIST (15)
#define HBN_STATUS_NOT_CONFIG (16)
#define HBN_STATUS_CHN_NOT_ENABLED (17)
#define HBN_STATUS_CHN_ALREADY_ENABLED (18)
#define HBN_STATUS_ALREADY_BINDED (19)
#define HBN_STATUS_NOT_BINDED (20)
#define HBN_STATUS_TIMEOUT (21)
#define HBN_STATUS_NOT_INITIALIZED (22)
#define HBN_STATUS_NOT_SUPPORT (23)
#define HBN_STATUS_NOT_PERM (24)
#define HBN_STATUS_NOMEM (25)
#define HBN_STATUS_INVALID_VNODE_FD (26)
#define HBN_STATUS_INVALID_ICHNID_FD (27)
#define HBN_STATUS_INVALID_OCHNID_FD (28)
#define HBN_STATUS_OPEN_OCHN_FAIL (29)
#define HBN_STATUS_OPEN_ICHN_FAIL (30)
#define HBN_STATUS_JSON_PARSE_FAIL (31)
#define HBN_STATUS_REQ_BUF_FAIL (32)
#define HBN_STATUS_QUERY_BUF_FAIL (33)
#define HBN_STATUS_SET_CONTROL_FAIL (34)
#define HBN_STATUS_GET_CONTROL_FAIL (35)
#define HBN_STATUS_NODE_START_FAIL (36)
#define HBN_STATUS_NODE_STOP_FAIL (37)
#define HBN_STATUS_NODE_POLL_ERROR (38)
#define HBN_STATUS_NODE_POLL_TIMEOUT (39)
#define HBN_STATUS_NODE_POLL_FRAME_DROP (40)
#define HBN_STATUS_NODE_POLL_HUP (41)
#define HBN_STATUS_NODE_ILLEGAL_EVENT (42)
#define HBN_STATUS_NODE_DEQUE_ERROR (43)
#define HBN_STATUS_ILLEGAL_BUF_INDEX (44)
#define HBN_STATUS_NODE_QUE_ERROR (45)
#define HBN_STATUS_FLUSH_FRAME_ERROR (46)
#define HBN_STATUS_INIT_BIND_ERROR (47)
#define HBN_STATUS_ADD_NODE_FAIL (48)
#define HBN_STATUS_WRONG_CONFIG_ID (49)
#define HBN_STATUS_BIND_NODE_FAIL (50)
#define HBN_STATUS_INVALID_VERSION (51)
#define HBN_STATUS_GET_VERSION_ERROR (52)
#define HBN_STATUS_MEM_INIT_FAIL (53)
#define HBN_STATUS_MEM_IMPORT_FAIL (54)
#define HBN_STATUS_MEM_FREE_FAIL (55)
#define HBN_STATUS_SYSFS_OPEN_FAIL (56)

#define HBN_STATUS_ERR_UNKNOW (128)

#define COMBINE_ERRCODE(module_id, err_info) ((int32_t)(((uint32_t)(module_id) << 16u) | ((uint32_t)(err_info) & 0xFFFFu)))

// cam module common error
#define HBN_STATUS_CAM_INVALID_NODE		COMBINE_ERRCODE(HB_CAM, HBN_STATUS_INVALID_NODE)       // 0x10001
#define HBN_STATUS_CAM_INVALID_NODETYPE		COMBINE_ERRCODE(HB_CAM, HBN_STATUS_INVALID_NODETYPE)   // 0x10002
#define HBN_STATUS_CAM_INVALID_HWID		COMBINE_ERRCODE(HB_CAM, HBN_STATUS_INVALID_HWID)       // 0x10003
#define HBN_STATUS_CAM_INVALID_CTXID		COMBINE_ERRCODE(HB_CAM, HBN_STATUS_INVALID_CTXID)      // 0x10004
#define HBN_STATUS_CAM_INVALID_NULL_PTR		COMBINE_ERRCODE(HB_CAM, HBN_STATUS_INVALID_NULL_PTR)   // 0x10008
#define HBN_STATUS_CAM_INVALID_PARAMETER	COMBINE_ERRCODE(HB_CAM, HBN_STATUS_INVALID_PARAMETER)  // 0x10009
#define HBN_STATUS_CAM_ILLEGAL_ATTR		COMBINE_ERRCODE(HB_CAM, HBN_STATUS_ILLEGAL_ATTR)       // 0x1000A
#define HBN_STATUS_CAM_INVALID_FLOW		COMBINE_ERRCODE(HB_CAM, HBN_STATUS_INVALID_FLOW)       // 0x1000B
#define HBN_STATUS_CAM_FLOW_EXIST		COMBINE_ERRCODE(HB_CAM, HBN_STATUS_FLOW_EXIST)         // 0x1000C
#define HBN_STATUS_CAM_FLOW_UNEXIST		COMBINE_ERRCODE(HB_CAM, HBN_STATUS_FLOW_UNEXIST)       // 0x1000D
#define HBN_STATUS_CAM_NODE_EXIST		COMBINE_ERRCODE(HB_CAM, HBN_STATUS_NODE_EXIST)         // 0x1000E
#define HBN_STATUS_CAM_NODE_UNEXIST		COMBINE_ERRCODE(HB_CAM, HBN_STATUS_NODE_UNEXIST)       // 0x1000F
#define HBN_STATUS_CAM_NOT_CONFIG		COMBINE_ERRCODE(HB_CAM, HBN_STATUS_NOT_CONFIG)         // 0x10010
#define HBN_STATUS_CAM_ALREADY_BINDED		COMBINE_ERRCODE(HB_CAM, HBN_STATUS_ALREADY_BINDED)     // 0x10013
#define HBN_STATUS_CAM_NOT_BINDED		COMBINE_ERRCODE(HB_CAM, HBN_STATUS_NOT_BINDED)         // 0x10014
#define HBN_STATUS_CAM_TIMEOUT			COMBINE_ERRCODE(HB_CAM, HBN_STATUS_TIMEOUT)            // 0x10015
#define HBN_STATUS_CAM_NOT_INITIALIZED		COMBINE_ERRCODE(HB_CAM, HBN_STATUS_NOT_INITIALIZED)    // 0x10016
#define HBN_STATUS_CAM_NOT_SUPPORT		COMBINE_ERRCODE(HB_CAM, HBN_STATUS_NOT_SUPPORT)        // 0x10017
#define HBN_STATUS_CAM_NOT_PERM			COMBINE_ERRCODE(HB_CAM, HBN_STATUS_NOT_PERM)           // 0x10018
#define HBN_STATUS_CAM_NOMEM			COMBINE_ERRCODE(HB_CAM, HBN_STATUS_NOMEM)              // 0x10019
#define HBN_STATUS_CAM_JSON_PARSE_FAIL		COMBINE_ERRCODE(HB_CAM, HBN_STATUS_JSON_PARSE_FAIL)    // 0x1001F
#define HBN_STATUS_CAM_SET_CONTROL_FAIL		COMBINE_ERRCODE(HB_CAM, HBN_STATUS_SET_CONTROL_FAIL)   // 0x10022
#define HBN_STATUS_CAM_GET_CONTROL_FAIL		COMBINE_ERRCODE(HB_CAM, HBN_STATUS_GET_CONTROL_FAIL)   // 0x10023
#define HBN_STATUS_CAM_NODE_START_FAIL		COMBINE_ERRCODE(HB_CAM, HBN_STATUS_NODE_START_FAIL)    // 0x10024
#define HBN_STATUS_CAM_NODE_STOP_FAIL		COMBINE_ERRCODE(HB_CAM, HBN_STATUS_NODE_STOP_FAIL)     // 0x10025
#define HBN_STATUS_CAM_NODE_ILLEGAL_EVENT	COMBINE_ERRCODE(HB_CAM, HBN_STATUS_NODE_ILLEGAL_EVENT) // 0x1002A
#define HBN_STATUS_CAM_INVALID_VERSION		COMBINE_ERRCODE(HB_CAM, HBN_STATUS_INVALID_VERSION)    // 0x10033
#define HBN_STATUS_CAM_GET_VERSION_ERROR	COMBINE_ERRCODE(HB_CAM, HBN_STATUS_GET_VERSION_ERROR)  // 0x10034
#define HBN_STATUS_CAM_ERR_UNKNOW		COMBINE_ERRCODE(HB_CAM, HBN_STATUS_ERR_UNKNOW)         // 0x10080

// cam module special error
#define HBN_STATUS_CAM_EXT_ERROR(num)		(HBN_STATUS_CAM_ERR_UNKNOW + (num))
#define HBN_STATUS_CAM_MOD_DLOPEN_ERROR		HBN_STATUS_CAM_EXT_ERROR(1)  // 0x10081
#define HBN_STATUS_CAM_MOD_CHECK_ERROR		HBN_STATUS_CAM_EXT_ERROR(2)  // 0x10082
#define HBN_STATUS_CAM_MOD_VERSION_ERROR	HBN_STATUS_CAM_EXT_ERROR(3)  // 0x10083
#define HBN_STATUS_CAM_VCON_ATTR_ERROR		HBN_STATUS_CAM_EXT_ERROR(4)  // 0x10084
#define HBN_STATUS_CAM_CSI_ATTR_ERROR		HBN_STATUS_CAM_EXT_ERROR(5)  // 0x10085
#define HBN_STATUS_CAM_SENSOR_DEV_ERROR		HBN_STATUS_CAM_EXT_ERROR(6)  // 0x10086
#define HBN_STATUS_CAM_DESERIAL_DEV_ERROR	HBN_STATUS_CAM_EXT_ERROR(7)  // 0x10087
#define HBN_STATUS_CAM_SENSOR_OP_ERROR		HBN_STATUS_CAM_EXT_ERROR(8)  // 0x10088
#define HBN_STATUS_CAM_CALIB_OP_ERROR		HBN_STATUS_CAM_EXT_ERROR(9)  // 0x10089
#define HBN_STATUS_CAM_DESERIAL_OP_ERROR	HBN_STATUS_CAM_EXT_ERROR(10) // 0x1008A
#define HBN_STATUS_CAM_POC_OP_ERROR		HBN_STATUS_CAM_EXT_ERROR(11) // 0x1008B
#define HBN_STATUS_CAM_TXSER_OP_ERROR		HBN_STATUS_CAM_EXT_ERROR(12) // 0x1008C
#define HBN_STATUS_CAM_VIN_ATTACH_ERROR		HBN_STATUS_CAM_EXT_ERROR(13) // 0x1008D
#define HBN_STATUS_CAM_I2C_OP_ERROR		HBN_STATUS_CAM_EXT_ERROR(14) // 0x1008E
#define HBN_STATUS_CAM_GPIO_OP_ERROR		HBN_STATUS_CAM_EXT_ERROR(15) // 0x1008F

// vin module common error
#define HBN_STATUS_VIN_INVALID_NODE COMBINE_ERRCODE(HB_VIN, HBN_STATUS_INVALID_NODE) //0xC0001
#define HBN_STATUS_VIN_INVALID_NODETYPE COMBINE_ERRCODE(HB_VIN, HBN_STATUS_INVALID_NODETYPE) //0xC0002
#define HBN_STATUS_VIN_INVALID_HWID COMBINE_ERRCODE(HB_VIN, HBN_STATUS_INVALID_HWID) //0xC0003
#define HBN_STATUS_VIN_INVALID_CTXID COMBINE_ERRCODE(HB_VIN, HBN_STATUS_INVALID_CTXID) //0xC0004
#define HBN_STATUS_VIN_INVALID_OCHNID COMBINE_ERRCODE(HB_VIN, HBN_STATUS_INVALID_OCHNID) //0xC0005
#define HBN_STATUS_VIN_INVALID_ICHNID COMBINE_ERRCODE(HB_VIN, HBN_STATUS_INVALID_ICHNID) //0xC0006
#define HBN_STATUS_VIN_INVALID_FORMAT COMBINE_ERRCODE(HB_VIN, HBN_STATUS_INVALID_FORMAT) //0xC0007
#define HBN_STATUS_VIN_INVALID_NULL_PTR COMBINE_ERRCODE(HB_VIN, HBN_STATUS_INVALID_NULL_PTR) //0xC0008
#define HBN_STATUS_VIN_INVALID_PARAMETER COMBINE_ERRCODE(HB_VIN, HBN_STATUS_INVALID_PARAMETER) //0xC0009
#define HBN_STATUS_VIN_ILLEGAL_ATTR COMBINE_ERRCODE(HB_VIN, HBN_STATUS_ILLEGAL_ATTR) //0xC000A
#define HBN_STATUS_VIN_INVALID_FLOW COMBINE_ERRCODE(HB_VIN, HBN_STATUS_INVALID_FLOW) //0xC000B
#define HBN_STATUS_VIN_FLOW_EXIST COMBINE_ERRCODE(HB_VIN, HBN_STATUS_FLOW_EXIST) //0xC000C
#define HBN_STATUS_VIN_FLOW_UNEXIST COMBINE_ERRCODE(HB_VIN, HBN_STATUS_FLOW_UNEXIST) //0xC000D
#define HBN_STATUS_VIN_NODE_EXIST COMBINE_ERRCODE(HB_VIN, HBN_STATUS_NODE_EXIST) //0xC000E
#define HBN_STATUS_VIN_NODE_UNEXIST COMBINE_ERRCODE(HB_VIN, HBN_STATUS_NODE_UNEXIST) //0xC000F
#define HBN_STATUS_VIN_NOT_CONFIG COMBINE_ERRCODE(HB_VIN, HBN_STATUS_NOT_CONFIG) //0xC0010
#define HBN_STATUS_VIN_CHN_NOT_ENABLED COMBINE_ERRCODE(HB_VIN, HBN_STATUS_CHN_NOT_ENABLED) //0xC0011
#define HBN_STATUS_VIN_CHN_ALREADY_ENABLED COMBINE_ERRCODE(HB_VIN, HBN_STATUS_CHN_ALREADY_ENABLED) //0xC0012
#define HBN_STATUS_VIN_ALREADY_BINDED COMBINE_ERRCODE(HB_VIN, HBN_STATUS_ALREADY_BINDED) //0xC0013
#define HBN_STATUS_VIN_NOT_BINDED COMBINE_ERRCODE(HB_VIN, HBN_STATUS_NOT_BINDED) //0xC0014
#define HBN_STATUS_VIN_TIMEOUT COMBINE_ERRCODE(HB_VIN, HBN_STATUS_TIMEOUT) //0xC0015
#define HBN_STATUS_VIN_NOT_INITIALIZED COMBINE_ERRCODE(HB_VIN, HBN_STATUS_NOT_INITIALIZED) //0xC0016
#define HBN_STATUS_VIN_NOT_SUPPORT COMBINE_ERRCODE(HB_VIN, HBN_STATUS_NOT_SUPPORT) //0xC0017
#define HBN_STATUS_VIN_NOT_PERM COMBINE_ERRCODE(HB_VIN, HBN_STATUS_NOT_PERM) //0xC0018
#define HBN_STATUS_VIN_NOMEM COMBINE_ERRCODE(HB_VIN, HBN_STATUS_NOMEM) //0xC0019
#define HBN_STATUS_VIN_INVALID_VNODE_FD COMBINE_ERRCODE(HB_VIN, HBN_STATUS_INVALID_VNODE_FD) //0xC002A
#define HBN_STATUS_VIN_INVALID_ICHNID_FD COMBINE_ERRCODE(HB_VIN, HBN_STATUS_INVALID_ICHNID_FD) //0xC002B
#define HBN_STATUS_VIN_INVALID_OCHNID_FD COMBINE_ERRCODE(HB_VIN, HBN_STATUS_INVALID_OCHNID_FD) //0xC002C
#define HBN_STATUS_VIN_OPEN_OCHN_FAIL COMBINE_ERRCODE(HB_VIN, HBN_STATUS_OPEN_OCHN_FAIL) //0xC002D
#define HBN_STATUS_VIN_OPEN_ICHN_FAIL COMBINE_ERRCODE(HB_VIN, HBN_STATUS_OPEN_ICHN_FAIL) //0xC002E
#define HBN_STATUS_VIN_JSON_PARSE_FAIL COMBINE_ERRCODE(HB_VIN, HBN_STATUS_JSON_PARSE_FAIL) //0xC002F

// vin module special error

//pym module common error
#define HBN_STATUS_PYM_INVALID_CTXID COMBINE_ERRCODE(HB_PYM, HBN_STATUS_INVALID_CTXID) //0x0F0004
#define HBN_STATUS_PYM_INVALID_NULL_PTR COMBINE_ERRCODE(HB_PYM, HBN_STATUS_INVALID_NULL_PTR) //0x0F0008
#define HBN_STATUS_PYM_INVALID_PARAMETER COMBINE_ERRCODE(HB_PYM, HBN_STATUS_INVALID_PARAMETER) //0x0F0009
#define HBN_STATUS_PYM_NODE_UNEXIST COMBINE_ERRCODE(HB_PYM, HBN_STATUS_NODE_UNEXIST) //0x0F000F
#define HBN_STATUS_PYM_INVALID_VERSION COMBINE_ERRCODE(HB_PYM, HBN_STATUS_INVALID_VERSION) //0x0F0033

//gdc module common error
#define HBN_STATUS_GDC_INVALID_NULL_PTR COMBINE_ERRCODE(HB_GDC, HBN_STATUS_INVALID_NULL_PTR) //0x060008
#define HBN_STATUS_GDC_INVALID_PARAMETER COMBINE_ERRCODE(HB_GDC, HBN_STATUS_INVALID_PARAMETER) //0x60009
#define HBN_STATUS_GDC_NODE_UNEXIST COMBINE_ERRCODE(HB_GDC, HBN_STATUS_NODE_UNEXIST) //0x6000f
#define HBN_STATUS_GDC_BIND_NODE_FAIL COMBINE_ERRCODE(HB_GDC, HBN_STATUS_BIND_NODE_FAIL) //0x60032
#define HBN_STATUS_GDC_INVALID_VERSION COMBINE_ERRCODE(HB_GDC, HBN_STATUS_INVALID_VERSION) //0x60033

//gdc module special error
#define HBN_STATUS_GEN_CFG_FAIL (129)
#define HBN_STATUS_GDC_GEN_CFG_FAIL COMBINE_ERRCODE(HB_GDC, HBN_STATUS_GEN_CFG_FAIL) //0x60081

//ISP module common error
#define HBN_STATUS_ISP_INVALID_NULL_PTR COMBINE_ERRCODE(HB_ISP, HBN_STATUS_INVALID_NULL_PTR) //0x0D0008
#define HBN_STATUS_ISP_INVALID_PARAMETER COMBINE_ERRCODE(HB_ISP, HBN_STATUS_INVALID_PARAMETER) //0x0D0009
#define HBN_STATUS_ISP_ILLEGAL_ATTR COMBINE_ERRCODE(HB_ISP, HBN_STATUS_ILLEGAL_ATTR) //0x0D000A
#define HBN_STATUS_ISP_NODE_UNEXIST COMBINE_ERRCODE(HB_ISP, HBN_STATUS_NODE_UNEXIST) //0x0D000f
#define HBN_STATUS_ISP_SET_CONTROL_FAIL COMBINE_ERRCODE(HB_ISP, HBN_STATUS_SET_CONTROL_FAIL) //0x0D0022
#define HBN_STATUS_ISP_GET_CONTROL_FAIL COMBINE_ERRCODE(HB_ISP, HBN_STATUS_GET_CONTROL_FAIL) //0x0D0023
#define HBN_STATUS_ISP_BIND_NODE_FAIL COMBINE_ERRCODE(HB_ISP, HBN_STATUS_BIND_NODE_FAIL) //0x0D0032
#define HBN_STATUS_ISP_INVALID_VERSION COMBINE_ERRCODE(HB_ISP, HBN_STATUS_INVALID_VERSION) //0x0D0033
#define HBN_STATUS_ISP_MEM_INIT_FAIL COMBINE_ERRCODE(HB_ISP, HBN_STATUS_MEM_INIT_FAIL) //0x0D0035
#define HBN_STATUS_ISP_MEM_IMPORT_FAIL COMBINE_ERRCODE(HB_ISP, HBN_STATUS_MEM_IMPORT_FAIL) //0x0D0036
#define HBN_STATUS_ISP_MEM_FREE_FAIL COMBINE_ERRCODE(HB_ISP, HBN_STATUS_MEM_FREE_FAIL) //0x0D0037
#define HBN_STATUS_ISP_SYSFS_OPEN_FAIL COMBINE_ERRCODE(HB_ISP, HBN_STATUS_SYSFS_OPEN_FAIL) //0x0D0038
#define HBN_STATUS_ISP_2A_ERROR COMBINE_ERRCODE(HB_ISP, HBN_STATUS_ERR_UNKNOW) //0x0D0080

//sth module common error
#define HBN_STATUS_STH_OPEN_ICHN_FAIL COMBINE_ERRCODE(HB_STITCH, HBN_STATUS_OPEN_ICHN_FAIL) //0x0A001E
#define HBN_STATUS_STH_OPEN_OCHN_FAIL COMBINE_ERRCODE(HB_STITCH, HBN_STATUS_OPEN_OCHN_FAIL) //0x0A001D
#define HBN_STATUS_STH_INVALID_NULL_PTR COMBINE_ERRCODE(HB_STITCH, HBN_STATUS_INVALID_NULL_PTR) //0x0A0008
#define HBN_STATUS_STH_INVALID_PARAMETER COMBINE_ERRCODE(HB_STITCH, HBN_STATUS_INVALID_PARAMETER) //0x0A0009
#define HBN_STATUS_STH_JSON_PARSE_FAIL COMBINE_ERRCODE(HB_STITCH, HBN_STATUS_JSON_PARSE_FAIL) //0x0A001F
#define HBN_STATUS_STH_INIT_BIND_ERROR COMBINE_ERRCODE(HB_STITCH, HBN_STATUS_INIT_BIND_ERROR) //0x0A002F
#define HBN_STATUS_STH_INVALID_VERSION COMBINE_ERRCODE(HB_STITCH, HBN_STATUS_INVALID_VERSION) //0x0A0033

//n2d module common error
#define HBN_STATUS_N2D_INVALID_PARAMETER COMBINE_ERRCODE(HB_N2D, HBN_STATUS_INVALID_PARAMETER) //0x170009
#define HBN_STATUS_N2D_NODE_UNEXIST COMBINE_ERRCODE(HB_N2D, HBN_STATUS_NODE_UNEXIST) //0x17000f
#define HBN_STATUS_N2D_BIND_NODE_FAIL COMBINE_ERRCODE(HB_N2D, HBN_STATUS_BIND_NODE_FAIL) //0x170032
#define HBN_STATUS_N2D_INVALID_VERSION COMBINE_ERRCODE(HB_N2D, HBN_STATUS_INVALID_VERSION) //0x170033

#ifdef __cplusplus
}
#endif

#endif
